using Autofac;
using APT.Infrastructure.Core;
using APT.Migrations;
using APT.NW.WebApi.App_Start;
using log4net;
using log4net.Config;
using Microsoft.AspNetCore.Authentication.JwtBearer;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.DependencyInjection.Extensions;
using Microsoft.IdentityModel.Tokens;
using Newtonsoft.Json;
using System;
using System.IO;
using System.Text;
using APT.BaseData.Domain.IServices;
using AutoMapper;
using APT.NW.WebApi.Models;
using System.Text.Encodings.Web;
using System.Text.Unicode;
using APT.NW.WebApi;
using APT.Infrastructure.Core.Utils;
using APT.Infrastructure.EF.Infrastructure;
using APT.Infrastructure.EF;
using APT.Infrastructure.EF.Extensions;
using APT.Infrastructure.Api;
using ConfigurationManager = APT.Infrastructure.Api.ConfigurationManager;
using APT.WebApi.Models;

namespace APT.NW.WebApi
{
    public partial class Startup
    {
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
          
            var repository = LogManager.GetRepository
                    (System.Reflection.Assembly.GetEntryAssembly());
			var fileInfo = new FileInfo("log4net.config");
			if(!fileInfo.Exists)
				fileInfo=new FileInfo(Path.Combine(System.AppContext.BaseDirectory, "log4net.config"));
			XmlConfigurator.Configure(repository, fileInfo);
            ConfigurationManager.Register(configuration);
            InitUtils.Init();
        }

        public IConfiguration Configuration { get; }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {

            // services.AddScoped<TenantInfo>();
            services.AddScoped<TenantInfo>();
            services.AddScoped<IConnectionResolver, HttpHeaderSqlConnectionResolver>();
            services.AddScoped<IConnectionGenerator, CombindedConnectionGenerator>();

            services.AddSqlServerPerConnection<EfDbContext>(settings =>
            {
                settings.ConnectionPrefix = "";
            });

            services.TryAddSingleton<IHttpContextAccessor, HttpContextAccessor>();

            services.AddCors(o => o.AddPolicy("AllowAllPolicy", builder =>
            {
                builder.AllowAnyOrigin()
                       .AllowAnyMethod()
                       .AllowAnyHeader();
            }));

            services.TryAddSingleton<IHttpContextAccessor, HttpContextAccessor>();
            //automapper
            AutoMapper.IConfigurationProvider config = new MapperConfiguration(cfg =>
            {
                cfg.AddProfile<MappingProfile>();
            });
            services.AddSingleton(config);
            services.AddScoped<IMapper, Mapper>();


            services.AddResponseCompression();
            //
            services.AddMvc(option => option.EnableEndpointRouting = false)
                .SetCompatibilityVersion(CompatibilityVersion.Version_3_0)
                .AddNewtonsoftJson(options =>
                {
                    options.SerializerSettings.ReferenceLoopHandling = ReferenceLoopHandling.Ignore;
                    options.SerializerSettings.ContractResolver = new JsonContractResolver();
                    options.SerializerSettings.NullValueHandling = NullValueHandling.Ignore;
                    options.SerializerSettings.DateFormatString = "yyyy-MM-dd HH:mm:ss";
                });

            services.AddSingleton(HtmlEncoder.Create(UnicodeRanges.All));
            //UpdateDatabase();
            services.RegisterBearAuth();
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IHostingEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
                app.UseHsts();
            }
            app.UseMiddleware<TenantInfoMiddleware>();
            Infrastructure.Api.HttpContext.Register(app.ApplicationServices.
                    GetRequiredService<IHttpContextAccessor>()
                );

       

            app.UseCors("AllowAllPolicy");

            app.UseAuthentication();

            app.UseHttpsRedirection();

            app.UseResponseCompression();

            app.UseMvc();
            app.UseStaticFiles();
          

            //fMOrganizationService.SetOrgCache();
            //APT.NW.WebApi.Utils.WebSokectHelper.Init();
        }

        public virtual void ConfigureContainer(ContainerBuilder builder)
        {
            builder.RegisterComponents();
        }

        
    }
}
